﻿@using Microsoft.AspNetCore.Components
@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Client.Services.Contracts
@using SPAWebApp.Shared.Models.ViewModels
@using SPAWebApp.Shared.Models.ViewModels.ConstructDocument
@inject IConstructDocumentService ConstructDocumentService

@if (CreateNewDocumentViewModel == null)
{
  <p>Wait, please...</p>
}
else
{
  <EditForm Model="@CreateNewDocumentViewModel" OnValidSubmit="@(async () => await CreateDocumentAsync())">
    <div class="form-group row">
      <label for="InputText" class="col-sm-2 col-form-label">Designation</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="Designation"  bind="@CreateNewDocumentViewModel.Designation" />
      </div>
    </div>
    <div class="form-group row">
      <label for="InputText" class="col-sm-2 col-form-label">Name</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="Name"  bind="@CreateNewDocumentViewModel.Name" />
      </div>
    </div>
    <button class="btn btn-info" title="OK" type="submit"><i class="fas fa-check-square"></i></button>
  </EditForm>
}
@functions {
  protected CreateNewDocumentVM CreateNewDocumentViewModel { get; set; } = new CreateNewDocumentVM();

  [Parameter]
  protected Action DocumentAdded { get; set; }

  // v.pogodaev: 
  [Parameter]
  protected Func<string, Task> DocumentAddedGetIdAsync { get; set; }

  private async Task CreateDocumentAsync()
  {
    // это должен быть вызов внешнего экншна, сам компонент не должен знать, как будет добавляться документ!
    try
    {
      var result = await ConstructDocumentService.CreateAsync(CreateNewDocumentViewModel);
      if (result != null)
      {
        Console.WriteLine("Object create");
      }
      await DocumentAddedGetIdAsync.Invoke(result);
      //DocumentAdded.Invoke(result);
      //Console.WriteLine("Инвок вызван");
    }
    catch (Exception e)
    {
      Console.WriteLine(e.Message);
    }

    
  }



}